#
# Copyright (C)2025 @BABOLO http://www.babolo.ru/
# pkg = lrwi-readcity
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: ques.pleaf.m4,v 1.3 2025/01/12 03:24:01 babolo Exp $
#
# 

eval
#perform 0002
CREATE TEMP TABLE SQNM(p)
     ( SQAT(i) int
     , SQAT(n) text
     , SQAT(p) text
     ) STRICT
;
#getpost _
#copyin  00_2
COPY p FROM stdin;
#wait
#close   _0_00_
#select  1002  --   
SELECT SQNM(que6).SQAT(ques) AS ques, SQNM(que6).SQAT(ques) AS poin
 FROM SQNM(x) JOIN SQNM(que6) ON(SQNM(x).SQAT(m) == SQNM(que6).SQAT(ques))
;
#select  _012  -- 
SELECT SQNM(que6).SQAT(head) AS head
 FROM SQNM(que6)
 WHERE SQNM(que6).SQAT(ques) == ?1
;
#style   00y00_
text
#display 00_00_
#close   _0_00_
#perform 0002
CREATE TEMP TABLE SQNM(pamparam)
     ( SQAT(ques) int
     , SQAT(poin) int
     , SQAT(answ) text
     , PRIMARY KEY(SQAT(ques), SQAT(poin))
     ) STRICT
;
#perform 0002
INSERT OR IGNORE INTO SQNM(pamparam)
 WITH b AS(SELECT SQNM(p).SQAT(n)                                    AS SQAT(n)
                , SQNM(p).SQAT(p)                                    AS SQAT(p)
                , CASE WHEN regexp('^[0-9]+_[0-9]+$', SQNM(p).SQAT(n))
                       THEN instr(SQNM(p).SQAT(n), '_')
                  END                                                AS SQAT(l)
            FROM SQNM(p)
          )
    , d AS(SELECT DISTINCT CAST(SQNM(p).SQAT(n) AS INTEGER) AS SQAT(ques)
            FROM SQNM(p)
            WHERE regexp('^[0-9]+$', SQNM(p).SQAT(n)) AND SQNM(p).SQAT(p) == 's'
          )
    , s AS(SELECT CAST(substring(b.SQAT(n), 1, b.SQAT(l) - 1) AS INTEGER) AS SQAT(ques)
                , CAST(substring(b.SQAT(n), b.SQAT(l) + 1) AS INTEGER)   AS SQAT(poin)
                , b.SQAT(p)                                             AS SQAT(answ)
            FROM b
            WHERE SQAT(l) IS NOT NULL
          )
 SELECT SQAT(ques), SQAT(poin), SQAT(answ) FROM d JOIN s USING(SQAT(ques))
;
#style   00y00d
form
#style   00y00h
hidd
#style   00y00o
ofrm
#style   00y00i
ifrm
#style   00y00k
knob
#select  9012
SELECT SQNM(qans).SQAT(objc)                                                    AS ques
     , SQNM(qans).SQAT(poin)                                                    AS poin
     , CASE WHEN SQNM(pamparam).SQAT(answ) IS SQNM(qans).SQAT(answ) THEN '' END AS color
     , CASE WHEN SQNM(pamparam).SQAT(answ) <> ''
            THEN regexp_replace( COALESCE(SQNM(qans).SQAT(full), SQNM(qans).SQAT(answ))
                               , '"'
                               , '\\"'
                               , 'g'
                               )
       END                                                                      AS answ
 FROM SQNM(qans) JOIN SQNM(pamparam) ON(   SQNM(qans).SQAT(poin) == SQNM(pamparam).SQAT(poin)
                                       AND SQNM(qans).SQAT(objc) == SQNM(pamparam).SQAT(ques)
                                       )
 WHERE SQNM(qans).SQAT(proj) = LRWINUM
   AND SQNM(qans).SQAT(objc) = ?1
;
#display 00900d
#display 00100i
#select  9012
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT)
     || '_'
     || CAST(SQNM(pamparam).SQAT(poin) AS TEXT) AS n
      , SQNM(pamparam).SQAT(answ)               AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
UNION
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT) AS n
      , 's'                                     AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
;
#display 00900h
#select  901_
SELECT 'CIPALITEVAR/LRWINUM/' || ?
#cat     09
#close   909
#display 00100o
#close   _0_00d
